// Version 1.01 Copyright  2004 by Jonas Mollberg
//All right reserved.                      

function populateSelect(form) {
document.forms[0].cType.options.length = 0;		
 	if (document.forms[0].root.selectedIndex != 0) {
 
    	var optionOne = new Option("Select a chord type...")
		document.forms[0].cType.options[0] = optionOne;	

		
		
		var empty =  new Array();	
		var C = new Array('major','5','/E','/G','/Bb','sus4','sus2','add9','add9 (alternate)','6','7','maj7','m','m6','m7','dim');
		var D = new Array('major','5','/F#','/A','/C','sus4','sus2','add9','6','7','maj7','m','m6','m7','dim');
		var E =  new Array('major','5','/G#','/G# (alternate)','/B','/D','sus4','add9','6','7','maj7','m','m6','m7','m7 (alternate)','dim');
		var F =  new Array('major','major (alternate)','5','/A','/C','/Eb','sus4','sus2','6','7','maj7','maj7 (alternate)','m','m6','m7','dim');
		var K =  new Array('major','5','/A#','/C#','/E','sus4','sus2','6','7','maj7','m','m6','m7','dim');
		var G =  new Array('major','major (alternate)','5','/B','/D','/F','sus4','sus2','add9','6','7','maj7','m','m6','m7','dim');
		var A = new Array('major','5','/B','/C#','/C# (alternate)','/E','/G','add9','sus4','sus2','6','7','maj7','m','m6','m7','dim');
		var L = new Array('major','5','/C','/D','/F','/Ab','sus4','sus2','6','7','maj7','m','m6','m7','dim');
		var B =  new Array('major','5','/D#','/F#','/A','sus4','sus2','6','7','maj7','m','m6','m7','dim');	



		var collection = new Array(empty,C,D,E,F,K,G,A,L,B)
		var root = new Array();
		root = collection[document.forms[0].root.selectedIndex];

		for(var i=0; i< root.length; i++) {
			var chordType = new Option(root[i]);
			document.forms[0].cType.options[i+1] = chordType;
   		}
	}
}
function getKey() {
 	var splitpoint1 = window.location.search.indexOf("cType");
	var key = window.location.search.substring(6,splitpoint1-1);
	//alert(key)
	return key 
}
function getChordType() {
	var splitpoint1 = window.location.search.indexOf("cType");
	var splitpoint2 = window.location.search.indexOf("hmenu");
	var ctype = unescape(window.location.search.substring(splitpoint1+6,splitpoint2-1));
	//alert(ctype)
	return ctype; 
}
function changeImg() {
	var key = getKey();
	var cType = getChordType();
	var option = "";
	if(key && cType) {
		if (cType.indexOf('(alternate)') != -1) {
			option = cType.substring(cType.length - 11)
			cType = cType.substring(0,cType.length - 12 )
		}	
		if (cType == "major") {
			cType ="";
		}
		if (cType.indexOf('m/') != -1) {
			cType = cType.substring(2);
			cType = "m"+cType;
		}
		if (cType.indexOf('7/') != -1) {
			cType = cType.substring(2);
			cType = "7"+cType;
		}
		if (cType.indexOf('/') != -1) {
			cType = cType.substring(1);
		}

		if (cType.indexOf('#') != -1) {
			cType = cType.substring(0,1)
			cType +="iss";
		}
		
		cType += option;
		if(key=="L") {
			key = "Bb";
		}
		if(key=="K") {
			key = "Fiss";
		}
		document.images["chordimg"].src = "basic/"+key+cType +".gif";
		writeFret()
	}
}
function writeRoot() {
	var key = getKey();
	if(key && key != "K" && key != "L") {
		document.write('<span class="key">'+key+'</span>');
	}
	 else if(key=="L") {
		document.write('<span class="key">B</span><img src="images/flat2.gif" hspace="2" align="top">');
	}
	else if(key=="K") {
		document.write('<span class="key">F</span><img src="images/sharp2.gif" hspace="2" align="top">');
	}
}

function getFancyCType(cType) {
		
		if (cType.indexOf('(alternate)') != -1) {
			cType = cType.substring(0,cType.length - 12 )
		}	
		
		if (cType == "major") {
			cType ="";
		}

		if (cType.indexOf('/') != -1) {
			if(cType.length <=3) {
				cType = cType.substring(0,3);
			}
			if(cType.length >=4) {
				cType = cType.substring(0,4);
			}
		}

		return cType;
}
function writeChordType() {
	var cType = getFancyCType(getChordType());
	var spanStyle ="chordtype";
	if(cType) {
		if (cType.indexOf('/') != -1) {
			spanStyle = "key";
		}
		if (cType.indexOf('#') != -1) {
			cType = cType.substring(0,cType.length - 1)
			cType += '<img src="images/sharp2.gif" hspace="2" align="top">';
		}
		if (cType.length == 4 && (cType.indexOf('m/') != -1 || cType.indexOf('7/') != -1)) {
			var firstLetter = cType.substring(0,1)
			var theRest = cType.substring(1,cType.length - 1)
			cType = '<span class="chordtyperaised">'+firstLetter+'</span>'+theRest+'<img src="images/flat2.gif" hspace="2" align="top">';
		}
		
		if (cType.length == 3 && (cType.indexOf('m/') != -1 || cType.indexOf('7/') != -1)) {
			var firstLetter = cType.substring(0,1)
			var theRest = cType.substring(1)
			cType = '<span class="chordtyperaised">'+firstLetter+'</span>'+theRest;
		}
		
		else if (cType.length == 3 && cType.indexOf('/') != -1 && cType.indexOf('b') != -1) {
			cType = cType.substring(0,2)
			cType += '<img src="images/flat2.gif" hspace="2" align="top">';
		}

		document.write('<span class="'+spanStyle+'">'+cType+'</span>');
	}
}
function writeTitleTag() {
	var cType = getFancyCType(getChordType());
	var key = getKey();
	if(key=="L") {
		key = "Bb";
	}
	if(key=="K") {
		key = "F#";
	}
		 document.write('<title>First position chords: '+key+cType+'</title>');
}

function writeFret() {	
	var theChord = getKey()+getFancyCType(getChordType()); 
	
	if(theChord == "Cm" || theChord == "Cm7" || theChord == "Cm(maj7)" || theChord == "C5") {
		document.images['fretimg'].src = "frets/3.gif";
	}
	else if(theChord == "Gm" || theChord == "G5" || theChord == "Gm7") {
		document.images['fretimg'].src = "frets/3.gif";
	}
	else if(theChord == "Bsus4") {
		document.images['fretimg'].src = "frets/2.gif";
	}
	else {
		document.images['fretimg'].src = "frets/empty.gif";
	}
}
function writeDescr() { 
	if(getKey() && getChordType()) {
		document.write("<a href='#' onmouseover='stm(Text[getKey()+getChordType()],Style[13])' onMouseOut='htm()'><img src='images/info.gif' align='absmiddle' border='0'> Chord info</a> | ");
	}
}
function writeHelp() {
	if(getKey() && getChordType()) {
		document.write("<a href='#' onmouseover='stm(Text[0],Style[13])' onMouseOut='htm()'><img src='images/help.gif' align='absmiddle' border='0'> Help</a>");
	}
}

function writeFretboard() {
	if(getKey() && getChordType()) {
		document.write(" | <a href='#' onmouseover='stm(Text[1],Style[14])' onMouseOut='htm()'><img src='images/zoom.gif' align='absmiddle' border='0'> Show fretboard</a>");
	}
}
function saveSelectedValues () {
			
			var root = document.forms[0].root.selectedIndex;
			var cType = document.forms[0].cType.selectedIndex;

			var savedSelectedValues = "";
           
          	savedSelectedValues += root + "`";
			savedSelectedValues += cType;
            savedSelectedValues = escape(savedSelectedValues);
			var expdate = new Date();
			var oneYearAhead = expdate.getTime() + (365*24*60*60*1000);
			expdate.setTime(oneYearAhead);
			
          
            document.cookie = "guitarbuddybasic=" + savedSelectedValues + ";expires="+expdate.toUTCString();
}
function restoreSelectedValues() {
		var root; 
		var cType; 
     	var singleVariableValue;
       	var allVariableValues = getCookieValue("guitarbuddybasic");
        
        if (allVariableValues != null) {
            singleVariableValue = allVariableValues.split('`');
			
			for (var i = 0; i < singleVariableValue.length; i++) {
               	root = singleVariableValue[0];
				cType  = singleVariableValue[1];
			}

			document.forms[0].root.options[root].selected = true;
			//eftersom cType popupmenyn inte finns nnu
			 if (root!=0) {
			 	populateSelect(document.forms[0])
				document.forms[0].cType.options[cType].selected = true;
			}
	
		}

}
function getCookieValue(cookieName)
      {
         var cookieValue = document.cookie;
         var cookieRegExp = new RegExp("\\b" + cookieName + "=([^;]+)");
         cookieValue = cookieRegExp.exec(cookieValue);

         if (cookieValue != null)
         {
            cookieValue = cookieValue[1];
            cookieValue = unescape(cookieValue);
         }

         return cookieValue;
      }

function submitForm(form) {
	var key = getKey();
	var cType = getChordType();
	var form = document.forms[0];
	var errorMsg = "Please select:";
	
	if(form.root.selectedIndex == 0) {
		errorMsg += "\n\n - root!";
	}
	else if (form.cType.selectedIndex == 0) {
		errorMsg += "\n\n - chord type";
	}
	if(form.root.selectedIndex != 0 && form.cType.selectedIndex != 0) {
	
		form.submit();	
		
	}
	else {
		alert(errorMsg);
	}

}
function printChords() {
	if(getKey() && getChordType()) {
		document.write(" | <a href='printbasic.html?root="+getKey()+"&cType="+escape(getChordType())+"&hmenu=' title='Click for printable version!'><img src='images/print.gif' align='absmiddle' border='0'> Print chord</a>");
	}
}

function restoreHistory() {
    
	for (var i=0; i< chordArray.length;  i++ ) {
    	
		var theChord =	chordArray[i];
		var theChordType = getFancyCType(theChord.substring(1));
		var theRoot = theChord.substring(0,1)
		if(theRoot=="L") {
			theRoot = "Bb";
		}
		if(theRoot=="K") {
			theRoot = "F#";
		}
		theChord = theRoot+theChordType;
		var theHref =	hrefArray[i];

		if(theHref !="" && theChord !="") {
			var theOption = new Option(theChord,theHref);
			document.forms[0].hmenu.options[i+1] = theOption;
		}
	}
			
}

function addToHistory() {

	var urlStr = window.location.search.substring(0);
	var key = getKey();
	var cType = getChordType();
	var toCompare = key+cType;
	var sameChord = 0;
		for (var i=0; i< chordArray.length;  i++ ){
			
			if(toCompare == chordArray[i]) {
				sameChord = 1;
			}
		}

		if(urlStr && key  && key !=""  && sameChord != 1){
			chordArray[chordArray.length] = key+cType;
			hrefArray[hrefArray.length] = urlStr;
			if(chordArray.length >= 50) {
				alert("You are beginning to reach the limit of your chord history!\nNew chords may not be added to the menu. To avoid this\nyou can clear your history before viewing more chords.")
			}
		}
}

function goToChord(){

	window.location.href = document.forms[0].hmenu.options[document.forms[0].hmenu.selectedIndex].value;

}

function clearBasicHistory() {
	
	if(confirm("Are you sure you want to clear your history?")) {
		var expdate = new Date();
		var oneYearAhead = expdate.getTime() - (365*24*60*60*1000);
		expdate.setTime(oneYearAhead);
		document.cookie = "basichistory=" + "" + ";expires="+ expdate.toUTCString();
		chordArray.length = 0;
		hrefArray.length = 0;
		document.forms[0].hmenu.options.length = 1;
	}
}