// Version 1.01 Copyright  2004 by Jonas Mollberg
//All right reserved.  

function getKey() {
 	var splitpoint1 = window.location.search.indexOf("pitch");
	var key = window.location.search.substring(5,splitpoint1-1);
	//alert(key)
	return key 
}
function getPitch() {
	var splitpoint1 = window.location.search.indexOf("pitch");
 	var splitpoint2 = window.location.search.indexOf("chord");
	var pitch = window.location.search.substring(splitpoint1+6,splitpoint2-1);
	return pitch; 
}
function getChordType() {
	var splitpoint1 = window.location.search.indexOf("chord");
	var splitpoint2 = window.location.search.indexOf("hmenu");
	var ctype = unescape(window.location.search.substring(splitpoint1+6,splitpoint2-1));
	//alert(ctype)
	return ctype; 
}
function changeImg () {
	var key = getKey(); 
	var ctype = getChordType();
	if(ctype && key) {
		document.images["chordimg6"].src = "movable/sixth/"+ctype+".gif";
		document.images["chordimg5"].src = "movable/fifth/"+ctype+".gif";
		setFretImgForString6()
		setFretImgForString5()
	}
} 
function writeDescr () {
	var key = getKey(); 
	var pitch = getPitch();
	var ctype = getChordType(); 
	if(ctype != "" && key != "") {
		document.write("<a href='#' onmouseover='stm(Text[getChordType()],Style[13])' onMouseOut='htm()'><img src='images/info.gif' align='absmiddle' border='0'> Chord information </a>| ");
	}
}
function writeHelp () {
	var key = getKey(); 
	var ctype = getChordType();  
	if(ctype != "" && key != "") {
		document.write("<a href='#' onmouseover='stm(Text[0],Style[13])' onMouseOut='htm()'><img src='images/help.gif' align='absmiddle' border='0'> Help</a>");
	}
}
function writeFretboard() {
	var key = getKey(); 
	var pitch = getPitch();
	var ctype = getChordType(); 
	if(ctype != "" && key != "") {
		document.write("<a href='#' onmouseover='stm(Text[1],Style[12])' onMouseOut='htm()'><img src='images/zoom.gif' align='absmiddle' border='0'> View fretboard </a>");
	}
}  
function writeKey () {
	var ctype = getChordType(); 
	var key = getKey(); 
	if(key  && ctype != "") {
		document.write("<span class='key'>"+key+"</span>");
	}
	else if(document.referrer.indexOf("movable.html") != -1 && key =="")
	document.write("<nobr><span class='warning'>Please select root! </span></nobr>");
}
function writePitch () {
	var key = getKey(); 
	var pitch = getPitch(); 
	var ctype = getChordType();
	if(pitch ==1 && ctype != "" && key != "") {
		document.write("<img src='images/sharp.gif' hspace='2'>");
	}
	if(pitch ==-1 && ctype != "" && key != "") {
		document.write("<img src='images/flat.gif' hspace='2'>");
	}
}
function getFancyCType(ctype) {
	if(ctype == "major") {
		ctype= "";
	}
	if(ctype == "#major") {
		ctype= "#";
	}
	if(ctype == "bmajor") {
		ctype= "b";
	}
	
	if (ctype.indexOf('opt') != -1) {
	 	ctype = ctype.substring(0,ctype.indexOf('opt'))
	} 
	if(ctype =="6(9)") {
		ctype = "6/9";
	}
	return ctype;

}
function writeChordType() {
	var key = getKey(); 
	var ctype = getFancyCType(getChordType());
	
	if(ctype != "major" && ctype != "6(9)"  && key != "") {
		document.write("<nobr><span class='chordtype'>"+ctype+"</span></nobr>");
	}

	else if(document.referrer.indexOf("movable.html") != -1 && ctype != "major" && ctype == "") {
		document.write("<nobr><span class='warning'>Please choose a chord type!</span></nobr>");
	}
}

function writeTitleTag() {
	var key = getKey();
	var pitch = getPitch();	
	var cType = getFancyCType(getChordType());
	
	if(pitch==1) {
		pitch = "#";
	}
	else if(pitch==-1) {
		pitch = "b";
	}
	else {
		pitch = "";
	}
	document.write('<title>Movable chords: '+key+pitch+cType+'</title>');
}

function getFretForString6() {
	var key = getKey(); 
	var pitch = getPitch();
	var ctype = getChordType(); 
	var fret = "";
	if(key=="C")
	fret=8
	if(key=="D")
	fret=10
	if(key=="E")
	fret=12
	if(key=="F")
	fret=1
	if(key=="G")
	fret=3
	if(key=="A")
	fret=5
	if(key=="B")
	fret=7
	
	fret = fret + parseInt(pitch);
	
	if(fret<1)
	fret += 12;
	
	
	if (fret == 2 && (ctype == "11" || ctype == "m11" || ctype == "7-9"))
	fret += 12;
	if (fret == 1 && (ctype == "11" || ctype == "7-9" || ctype == "9" || ctype == "6" || ctype == "7-5" || ctype == "dim" || ctype == "m11" || ctype == "m6" ||  ctype == "m7-5" || ctype == "maj7+11" || ctype == "6(9)" || ctype == "sus2"))
	fret += 12;
	
	if(key == "E" && fret == 13 && ctype != "11" && ctype != "6" && ctype != "7-5" && ctype != "dim" && ctype != "m11" && ctype != "m6" &&  ctype != "m7-5" && ctype != "maj7+11" && ctype != "6(9)" && ctype != "sus2" && ctype != "9" && ctype != "7-9")
	fret -= 12;
	return fret;
}	

function writeFret6 () {
	var key = getKey(); 
	var ctype = getChordType();
	var fret = getFretForString6();
	if( fret !="NaN" && ctype != "" && key != "")
	document.write("<span class='fret'><img src='images/bullet.gif' align='absmiddle'> = Root on string 6, fret "+ fret+"</span><br>");
}
function setFretImgForString6() {
	var key = getKey(); 
	var ctype = getChordType();
	var fret = getFretForString6();
	var fretflag ="one6";
	
	if (ctype == "11" || ctype == "m11" || ctype == "7-9") {
		fret = fret-2;
	}
	else if (ctype == "9" || ctype == "6" || ctype == "7-5" || ctype == "dim" || ctype == "m6" ||  ctype == "m7-5" || ctype == "maj7+11" || ctype == "6(9)" || ctype == "sus2") {
		fret = fret-1;
	}

	if(fret !="NaN" && ctype != "" && key != "") 
	document.images[fretflag].src = "frets/"+fret+".gif";
}

function getFretForString5() {
	var key = getKey(); 
	var pitch = getPitch(); 
	var ctype = getChordType();
	var fret = "";
	var fretflag ="";
	
	if(key=="C")
	fret=3
	if(key=="D")
	fret=5
	if(key=="E")
	fret=7
	if(key=="F")
	fret=8
	if(key=="G")
	fret=10
	if(key=="A")
	fret=12
	if(key=="B")
	fret=2
	
	fret = fret + parseInt(pitch);
	
	if(fret<1)
	fret += 12;
	
	
	if (fret == 2 && (ctype == "11" || ctype == "6" || ctype == "m11" || ctype == "m9" || ctype == "7opt"))
	fret += 12;
	if (fret == 1 && (ctype == "11" || ctype == "6" || ctype == "7+9" || ctype == "7-9" || ctype == "9" ||  ctype == "m11" ||  ctype == "m6" ||  ctype == "m9" || ctype == "maj9" || ctype == "maj7+11" || ctype == "dim" || ctype == "6(9)" || ctype == "13-9" || ctype == "7opt"))
	fret += 12;
	
	if(key == "A" && fret == 13 && ctype != "11" && ctype != "6" && ctype != "7+9" && ctype != "7-9" && ctype != "9" &&  ctype != "m11" &&  ctype != "m6" &&  ctype != "m9" && ctype != "maj9" && ctype != "maj7+11" && ctype != "dim" && ctype != "6(9)" && ctype != "13-9" && ctype != "7opt")
	fret -= 12;
	return fret;
}	

function writeFret5 () {
	var key = getKey(); 
	var ctype = getChordType();
	var fret = getFretForString5();	
	
	if(fret !="NaN" && ctype != "" && key != "") 
	document.write("<span class='fret'><img src='images/bullet.gif' align='absmiddle'> = Root on string 5, fret "+ fret+"</span><br>");

}
function setFretImgForString5() {
	var key = getKey(); 
	var ctype = getChordType();
	var fret = getFretForString5();
	var fretflag ="one5";
	
	if (ctype == "11" || ctype == "6" || ctype == "m11" || ctype == "m9" || ctype == "7opt") {
		fret = fret-2;
	}
	else if (ctype == "7+9" || ctype == "7-9" || ctype == "9" || ctype == "m6" || ctype == "maj9" || ctype == "maj7+11" || ctype == "dim" || ctype == "6(9)" || ctype == "13-9") {
		fret = fret-1;
	}

	if(fret !="NaN" && ctype != "" && key != "") 
	document.images[fretflag].src = "frets/"+fret+".gif";
}
function submitForm(form) {
	var key = getKey();
	var cType = getChordType();
	var form = document.forms[0];
	var errorMsg = "Please select:";
	
	if(form.key.selectedIndex == 0) {
		errorMsg += "\n\n - root!";
	}
	if (form.chord.selectedIndex == 0 || form.chord[form.chord.selectedIndex].value =="") {
		errorMsg += "\n\n - chord type";
	}
	if(form.key.selectedIndex != 0 && form.chord.selectedIndex != 0 && form.chord[form.chord.selectedIndex].value !="") {
		form.submit()
	}
	else {
		alert(errorMsg);
	}

}

function printChords() {
	if(getKey() && getChordType()) {
		
		document.write(" | <a href='printmovable.html?key="+getKey()+"&pitch="+getPitch()+"&chord="+escape(getChordType())+"&hmenu=' title='Click for printable version!'><img src='images/print.gif' align='absmiddle' border='0'> Print chords</a>");

	}
}

function restoreHistory() {
    
	for (var i=0; i< chordArray.length;  i++ ) {
    	
		var theChord =	chordArray[i];
		var theChordType = getFancyCType(theChord.substring(1));
		var theRoot = theChord.substring(0,1)
		theChord = theRoot+theChordType;
		var theHref =	hrefArray[i];

		if(theHref !="" && theChord !="") {
			var theOption = new Option(theChord,theHref);
			document.forms[0].hmenu.options[i+1] = theOption;
		}
	}
			
}

function addToHistory() {

	var urlStr = window.location.search.substring(0);
	var key = getKey();
	var pitch =	getPitch();
	if(pitch==1) {
		pitch = "#";
	}
	else if(pitch==-1) {
		pitch = "b";
	}
	else {
		pitch = "";
	}
	var cType = getChordType();
	var toCompare = key+pitch+cType;
	var sameChord = 0;
	
		for (var i=0; i< chordArray.length;  i++ ){
			
			if(toCompare == chordArray[i]) {
				sameChord = 1;
			}
		}

		if(urlStr && key  && key !=""  && sameChord != 1){
			chordArray[chordArray.length] = key+pitch+cType;
			hrefArray[hrefArray.length] = urlStr;
			if(chordArray.length >= 50) {
				alert("You are beginning to reach the limit of your chord history!\nNew chords may not be added to the menu. To avoid this\nyou can clear your history before viewing more chords.")
			}
		
		}

		
}
function goToChord(){

	window.location.href = document.forms[0].hmenu.options[document.forms[0].hmenu.selectedIndex].value;

}
function clearMovableHistory() {
	
	if(confirm("Are you sure you want to clear your history?")) {
		var expdate = new Date();
		var oneYearAhead = expdate.getTime() - (365*24*60*60*1000);
		expdate.setTime(oneYearAhead);
		document.cookie = "movablehistory=" + "" + ";expires="+ expdate.toUTCString();
		chordArray.length = 0;
		hrefArray.length = 0;
		document.forms[0].hmenu.options.length = 1;
	}
}