/*

Text[...]=[title,text]

Style[...]=[TitleColor,TextColor,TitleBgColor,TextBgColor,TitleBgImag,TextBgImag,TitleTextAlign,TextTextAlign, TitleFontFace, TextFontFace, TipPosition, StickyStyle, TitleFontSize, TextFontSize, Width, Height, BorderSize, PadTextArea, CoordinateX , CoordinateY, TransitionNumber, TransitionDuration, TransparencyLevel ,ShadowType, ShadowColor]
*/

var FiltersEnabled = 0 // if your not going to use transitions or filters in any of the tips set this to 0
//Hjlp och fretboard
Text[0]=["Help","<img src='images/hands.gif' hspace='24'><br><br>The digits below the chord diagrams are indicating which fingers to use in your left hand.<br><br>An \"X\" indicates that he string is not part of the chord and therefore not played.<br><br>Digit in parenthesis indicates that the string is part of the chord but may be excluded.<br><br>The &quot;bracket&quot; sign means that the chord is a barr&eacute; chord, i e the forefinger press several strings at the same time.<br><br>Roman numbers indicate on which fret the chord diagram starts."]
Text[1]=["The notes on the first 12th frets","The diagram below shows the root notes on the twelve first frets. (Note! Except for being raised one octave, the notes on the 13th fret are equivalent to the notes on 1st fret, the notes on 14th fret with the second and so on). The bottom line in the fretboard diagram is equivalent to the thickest string on the guitar - string 6. The notes displayed here are the same as the white keys on the piano. The places without a circle contain either a raised note or a lowered one; i.e. equivalent to a black key on the piano. The arrows below shows what effect the accidentals have. For an example compare an Fm with a F#m or a Gm with a Gbm.<br><br><img src='images/fretboard.gif' vspace='5' hspace='10'><br><img src='images/accidentals.gif' vspace='6' hspace='15'>"]

//Flyttbara ackord

Text['major']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Major third</li><li>Fifth</li> <li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Major third</li><li>Fifth</li>"]
Text['+5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Root</li><li>Major third</li><li>Raised fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Root</li><li>Major third</li><li>Raised fifth</li>"]
Text['add9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Ninth</li><li>Major third</li><li>(Fifth)</li> <li>(Root)</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Ninth</li><li>Major third</li><li>(Fifth)</li>"]
Text['sus4']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Fourth</li><li>Fifth</li> <li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Fourth</li><li>Fifth</li>"]
Text['sus2']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Second (same as ninth)</li><li>Fifth</li> <li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Second (same as ninth)</li><li>(Fifth)</li>"]
Text['6']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Sixth</li><li>Major third</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Sixth</li><li>Root</li>"]
Text['6(9)']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Major third</li><li>Sixth</li><li>Ninth</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Sixth</li><li>Ninth</li><li>Fifth</li>"]
Text['7']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Major third</li><li>Fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Major third</li><li>Fifth</li>"]
Text['7opt']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Major third</li><li>Seventh</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Third</li><li>Seventh</li><li>Root</li>"]
Text['7sus4']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Fourth</li><li>Fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Fourth</li><li>Fifth</li>"]
Text['7+5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Raised fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Raised fifth</li>"]
Text['7-5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Lowered fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Lowered fifth</li><li>Seventh</li><li>Major third</li>"]
Text['7-9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Lowered ninth</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Seventh</li><li>Lowered ninth</li>"]
Text['7+9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>(Fifth)</li><li>Raised ninth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Seventh</li><li>Raised ninth</li>"]
Text['maj7']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Major seventh</li><li>Major third</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Major seventh</li><li>Major third</li><li>Fifth</li>"]
Text['maj7+11']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Major seventh</li><li>Major third</li><li>Raised eleventh</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major seventh</li><li>Major third</li><li>Raised eleventh</li>"]
Text['maj9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Major seventh</li><li>Major third</li><li>Fifth</li><li>Ninth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Major seventh</li><li>Ninth</li>"]
Text['9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Ninth</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Seventh</li><li>Ninth</li>"]
Text['11']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Ninth</li><li>Eleventh</li><br><b>Root on string 5:</b><br><li>Root</li><li>Seventh</li><li>Ninth</li><li>Eleventh</li>"]
Text['11opt']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Ninth</li><li>Eleventh</li><li>Seventh</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Eleventh</li><li>Seventh</li><li>Ninth</li><li>(Fifth)</li>"]
Text['13']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Thirteenth</li><li>(Root)</li><br><b>Root on string 5:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Thirteenth</li>"]
Text['13-9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Major third</li><li>Thirteenth</li><li>Lowered ninth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Major third</li><li>Seventh</li><li>Lowered ninth</li><li>Thirteenth</li>"]

Text['m']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Minor third</li><li>Fifth</li> <li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Root</li><li>Minor third</li><li>Fifth</li>"]
Text['m(add9)']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Ninth</li><li>Minor third</li><li>(Fifth)</li> <li>(Root)</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Ninth</li><li>Minor third</li><li>(Fifth)</li>"]
Text['m6']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Sixth</li><li>Minor third</li><li>Fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Sixth</li><li>Minor third</li><li>Fifth</li>"]
Text['m7']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Minor third</li><li>Fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Minor third</li><li>Fifth</li>"]
Text['m7+5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Minor third</li><li>Raised fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Raised fifth</li><li>Seventh</li><li>Minor third</li><br>(First string is not part of the chord but sounds good anyway!)"]
Text['m7-5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Minor third</li><li>Lowered fifth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Lowered fifth</li><li>Seventh</li><li>Minor third</li>"]
Text['m(maj7)']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>(Fifth)</li><li>Major seventh</li><li>Minor third</li><li>Fifth</li><li>(Root)</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Major seventh</li><li>Minor third</li><li>Fifth</li>"]
Text['m9']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Seventh</li><li>Minor third</li><li>Fifth</li><li>Ninth</li><br><b>Root on string 5:</b><br><li>Root</li><li>Minor third</li><li>Seventh</li><li>Ninth</li>"]
Text['m11']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Seventh</li><li>Minor third</li><li>Eleventh</li><br><b>Root on string 5:</b><br><li>Root</li><li>Seventh</li><li>Minor third</li><li>Eleventh</li>"]
Text['dim']=["Contents (interval)","Diminished chords are a bit complicated to deduce. The easiest way to deduce a diminished chord is to look at it as a major seventh chord, with lowered ninth and no root! For example, you can look at a B diminished chord as a G7-9 without root."]
Text['5']=["Contents (interval)","<b>Root on string 6:</b><br><li>Root</li><li>Fifth</li><li>Root</li><br><b>Root on string 5:</b><br><li>Root</li><li>Fifth</li><li>Root</li>"]


Style[0]=["white","black","#000099","#E8E8FF","","","","","","","","","","",200,"",2,2,10,10,51,1,0,"",""]
Style[1]=["white","black","#000099","#E8E8FF","","","","","","","center","","","",200,"",2,2,10,10,"","","","",""]
Style[2]=["white","black","#000099","#E8E8FF","","","","","","","left","","","",200,"",2,2,10,10,"","","","",""]
Style[3]=["white","black","#687681","white","","","","","","","float","","","",200,"",2,8,10,10,"","","","",""]
Style[4]=["white","black","#000099","#E8E8FF","","","","","","","fixed","","","",200,"",2,2,1,1,"","","","",""]
Style[5]=["white","black","#000099","#E8E8FF","","","","","","","","sticky","","",200,"",2,2,10,10,"","","","",""]
Style[6]=["white","black","#000099","#E8E8FF","","","","","","","","keep","","",200,"",2,2,10,10,"","","","",""]
Style[7]=["white","black","#000099","#E8E8FF","","","","","","","","","","",200,"",2,2,40,10,"","","","",""]
Style[8]=["white","black","#000099","#E8E8FF","","","","","","","","","","",200,"",2,2,10,50,"","","","",""]
Style[9]=["white","black","#000099","#E8E8FF","","","","","","","","","","",200,"",2,2,10,10,51,0.5,75,"simple","gray"]
Style[10]=["white","black","black","white","","","right","","Impact","cursive","center","",3,5,200,150,5,20,10,0,50,1,80,"complex","gray"]
Style[11]=["white","black","#000099","#E8E8FF","","","","","","","","","","",200,"",2,2,10,10,51,0.5,45,"simple","gray"]
Style[12]=["white","#666666","#687681","white","","","","","","","left","","","",200,"",2,4,10,10,"","","","",""]
Style[13]=["white","#666666","#687681","white","","","","","","","","","","",200,"",2,4,10,10,"","","","",""]
Style[14]=["white","black","#687681","white","","","","","","","center","","","",200,"",2,4,10,10,"","","","",""]
applyCssFilter()

